// Author: A.Voss@FH-Aachen.de
//
// inheritance
// tags: class

#include <iostream>
#include <cstdlib>
using namespace std;

#include "../../include/tools.h"

class A 
{
protected:
    int n;
    
public: 
    // no std-cstr
    A(int N) : n(N) { tools_log(); cout << "ctor A(" << n << ")" << endl; }
    ~A()            { tools_log(); cout << "dtor A(" << n << ")" << endl; }
    
    int getn() const { return n; }
};

class B : public A      // all public members of A are public in B
{
protected:
    char c;
    
public: 
    // as there is no std-A-cstr, we have to call one explicitly
    // B is allowed to access n as it is protected in A
    B(int N) : A(N), c('A') { tools_log(); cout << "ctor B(" << n << ")" << endl; }
    ~B()                    { tools_log(); cout << "dtor B(" << n << ")" << endl; }
};

int main()
{
    tools_log(); cout << "define objects" << endl;

    A a(1);
    B b(2);     // b is also of type A and a little bit more (char c)
    
    tools_log(); cout << "a.n = " << a.getn() << ", b.n = " << b.getn() << endl;
    
    tools_log(); cout << "size A = " << sizeof(A) << ", size B = " << sizeof(B) << endl;
    
    return EXIT_SUCCESS;
}

